'use strict';

// (C) BLACK MEW TEAM (2021), Apache-2.0

const spawn = require('child_process').spawn;
const np = require('path').normalize;
const fs_access = require('fs').promises.access;
const fs_readfile = require('fs').promises.readFile;
const fs_writefile = require('fs').promises.writeFile;


const fail_line_1 = 'InitializationFailed'
const success_line = 'GameActionHandler.cpp'
// 'TryingToCatchUp' works *most* of the time and is a bit faster...
// but we need to wait for the real sync state here.

// DO NOT!!
// DO NOT run this script over your usual client you play with!

// IT DOES NOT CHECK IF THIS IS THE REAL ONE!
// IT *MAY* AND *WILL* OVERWRITE SOME DATA!
// so pls, make sure you make a copy before running this script.
// best: use a "zip version", for, we have hardcoded some pathes inside :>


// connects a factorio client with a new username to a certain port.
// usage:
// const clientelle = require('./dummy_spawn') // use appropriate path
// ...
// inside an async loop:
// const status = await clientelle.run({
//   path_to_client: path_to_client_factorio_folder,
//   host: '127.0.0.1',
//   port: '34197',
//   username: '__dummy__',
// })

// does NOT support a token thing.
// do NOT use it for "public" logins.
// you need WAY more than this if you really want to go that way.

// It is meant as a "spawn dummies" test tool,
// a way around a color-of=neutral-force problem.

// being a "debug tool" it is fine as it is.
// but pls, "--bind" your servers to localhost in case you use it. For safety.
// You know, we can't exactly enter a password...
// we CAN do a player.connect via scenario lua/rcon, but that needs confirmation.
// and... since we do not go public with dummies,
// just accept no-password run for this as well.

// whatever, done in hope of being useful.
// this is from internal tools, so...
// you should not see this unless authorised? Or you got the src pack prob.


// what .run does:
// wipes the last log,
// sets a username + no-token to player-data.json
// runs a heavily "shrinked" client to connect the map.
// on having connected/timeouted kills the factorio client in a second-or-two.
// once finished gives a {status:'ok'} or {status:'fail'} as a promise resolve.
// NB: both are "fulfilled", check the status.


// a heavily truncated logparser :>
// don't do this dark magic of a necro kind at home!
const make_log_killer = (kill_me) => {
  // set `kill_me.please = true` to kill the factorio child process.
  // probably not the best solution, but what works works.

  // FOR DEBUG!
  // we have console.log in default switch option for you.
  // I also don't see any reason you would need to know the error actually.
  // like... there is a log ... for curiosity?
  // but should factorio change log anchors, just update them from logparser.
  // or enable console.log and do it by hand, you, peasant. :>
  // But really, just make it sync with the log parser in case of crazy stuff.

  let debug_hide_starter_crap = true

  return (data) => {
    // you may want to trim the line as well. But well, we ... do not care.
    const lines = data.toString().split('\n').filter(l => (l.length > 0));
    lines.forEach(line => {
      const tokens = line.split(' ').filter(t => (t.length > 0))
      const message = tokens.slice(1).join(' ')

      // if known messages (see the factorio internal logger or look at logs)
      switch (message) {
        case 'Goodbye':
          // we missed the target line. probably a manual stop.
          // kill the launcher anyways
          kill_me.please = true
          break;
        case 'Factorio initialised':
          // mainly for debug/ updating the flags purposes
          debug_hide_starter_crap = false
          break;

        default:
          // even more crazy tokens filtering awaits you.
          // though, let's "cheat", we only seek 2 events anyways.
          // one is no server exist (we do not even get to connected state)
          // second is "we got to the server and are good to stop"

          // truth be told, you don't even need to load the map.
          // hell, you can even "dummy" to the public server.
          // ... even to the password-locked one.
          // cuz... who needs passwords? lol. Whatever.
          // iirc even whitelist is not a stopgate. But I've derailed too much.
          // for this simple case we need to get up to catchup point.

          // first check for the signature of the failure:
          // we have 2 of them to this state and from this state btw.
          if (message.indexOf(fail_line_1) > -1) {
            // FAILURE!
            kill_me.please = true
            break;
          }


          // now check for the case we've been connected?
          if (message.indexOf(success_line) > -1) {
            // yay! roll them up and good to go!
            // success!
            kill_me.ok = true
            kill_me.please = true
            break;
          }


          if (!debug_hide_starter_crap) {
            // for the debug purposes.
            // should you need it, un-comment it here and use a manual runner.
            // the old one by @D in this folder should still work!

            // console.log(message)
          }

          break;
      }

    })
  }
}

const no_lockfile = async (path_to_folder) => {
  // fs access checks the file existence
  // either resolve fast or resolve over timeout with failure;

  const prom = new Promise((fulfill, reject) => {
    const timeout = setTimeout(() => {
      clearInterval(timer)
      clearTimeout(timeout)
      fulfill(false)
    }, 10_000);
    const timer = setInterval(async () => {
      const test = await fs_access(np(path_to_folder + '/.lock')).then(r => ((r === undefined))).catch(e => false)
      if (!test) {
        clearInterval(timer)
        clearTimeout(timeout)
        fulfill(true)
      }
    }, 250);
  })
  return prom
}


const name_flipper = async (new_name, path_to_folder) => {
  // we might want fs-extras, rimraff and the like, but this is the standalone!
  // NB jsonparse is sync and stales the thread.
  const pdata_path = np(path_to_folder + '/player-data.json')

  const pdata = await fs_readfile(pdata_path, { encoding: 'utf-8' }).
    // can actually throw and kill your script!
    // do you want to trycatch this one? Or do we want a refactor here?
    then(JSON.parse).
    catch(e => undefined)
  if (pdata === undefined) {
    return false
  }

  // hey, what about a warning on non-empty service token?
  // do it at dog service, it does not belong here imo.
  // use a replacer? or link a generic?
  // no, keep it for clarity, speed is not the real needle eye here anyways.
  pdata['service-username'] = new_name
  pdata['service-token'] = ''

  // ! we need to have ensured the .lock is not present!
  // cuz if we overwrite locked data it shall just be overwritten later!!
  // whatever, check it at script, you'll be fine.
  const prom = fs_writefile(pdata_path, JSON.stringify(pdata)).
    then(f => true).catch(e => false)
  return prom
}

const run = async (params) => {
  const logger = params.logger ?? { warn: (msg) => (console.error(msg)) }
  if (params.path === undefined) {
    logger.warn('dummy_spawn: fail. You forgot to specify a client path.')
    return { status: 'fail' };
  }

  const host = params.host ?? '127.0.0.1';
  const port = params.port ?? '34197';
  const dummy_name = params.username ?? '__dummy__';
  const path_to_client = params.path;


  // first pls ensure we are not stepping on "tails" of the prev version.
  // check for lockfile for 10 seconds 4 time per second.
  const no_lockfile_status = await no_lockfile(path_to_client)
  if (!no_lockfile_status) {
    logger.warn('dummy_spawn: fail. 10 sec passed and we still see .lock in the folder!')
    return { status: 'fail' };
  }

  // flip a username data
  // we may want to chain the proms later, but well, it "works" for now.
  // yup do not refactor it unless we really run into issues. Stash it for now.
  const flip_status = await name_flipper(dummy_name, path_to_client)
  if (!flip_status) {
    logger.warn('dummy_spawn: fail. Nameflip failed? Eh, how?')
    return { status: 'fail' };
  }

  // now spawn a factorio instance.
  // we need to kill it on task completion so let's make a simple "parser".
  // we could use log-parser but let's make this a decoupled version for now.
  const cmd = np(path_to_client + '/bin/x64/factorio')
  const args = [
    '--verbose',
    // '--disable-prototype-history', // wubes have broken that one? IDK, it crashes! See issue#%%%%.
    '--force-graphics-preset', 'very-low',
    '--graphics-quality', 'very-low',
    '--video-memory-usage', 'low',
    // '--no-log-rotation', // let them rotate, we do not need them for debug usually anyways.
    '--disable-audio',
    '--window-size', '640x480', // you can go lower, but seems to get the same speed anyways.
    '--shader', 'disable', // does nothing for this setup lol
    '--config',
    np(path_to_client + '/config/config.ini'),
    '--mp-connect',
    `${host}:${port}`,
  ]

  const opts = {
    cwd: path_to_client,
    stdio: ['pipe', 'pipe', 'pipe'], // !! FIXME: change this before getting to prod !!
  }
  const kill_them = { please: false, ok: false, stopped: false }
  const child = spawn(cmd, args, opts)
  child.stdout.on('data', make_log_killer(kill_them))
  child.on('close', () => { kill_them.stopped = true })

  const prom = new Promise((fulfill, reject) => {
    // a bit of a wrong idea.. let it be for now tho.
    // eslint-disable-next-line prefer-const
    let timer;
    // eslint-disable-next-line prefer-const
    let checker;

    let kill_sent = false

    const kill_fn = () => {
      if (child?.kill !== undefined) {
        if (!kill_sent) {
          child.kill('SIGINT')
          kill_sent = true
        }

        // quits so fast that the player even drops out with a timeout instead!
        // child.kill('SIGKILL')
        // remember to erase the lock btw!
      }
    }
    const ffl_fn = (reason) => {
      clearTimeout(timer)
      clearInterval(checker)
      fulfill(reason)
    }

    timer = setTimeout(() => {
      kill_fn()
    }, 30 * 1000); // 30 sec max. I KNOW it is not enough for mods. But spare me.

    checker = setInterval(() => {
      if (kill_them.please) {
        kill_fn()
      } else {
        // pass
      }
      if (kill_them.stopped) {
        ffl_fn((kill_them.ok) ? ('ok') : ('fail'))
      }
    }, 500); // twice per second should be more than fine

  })

  return prom.then(result => ({ status: result }))
}

module.exports = { run: run }
